from sync_amz_data.public import SBClient
from sync_amz_data.settings import AWS_LWA_CLIENT, DATA_PATH
from ._base import query_shop_info, BaseTask

import logging
from pydantic import BaseModel
from typing import Literal, List, Dict
from datetime import date

logger = logging.getLogger(__name__)


class SBCampaign(BaseModel):
    portfolioId: str = None
    campaignId: str
    name: str
    budgetType: Literal['DAILY', 'LIFETIME']
    state: Literal['ENABLED', 'PAUSED', 'ARCHIVED']
    budget: float
    ruleBasedBudget: dict = None
    brandEntityId: str = None
    isMultiAdGroupsEnabled: bool = None
    goal: str = None
    bidding: dict = None
    startDate: date = None
    endDate: date = None
    productLocation: str = None
    tags: dict = None
    costType: str = None
    smartDefault: List[str] = None
    extendedData: dict = None


class SBTask(BaseTask):
    AmzAdClientClass = SBClient

    def change_campaign(self, data: dict):
        return data

    def change_ad_group(self, data: dict):
        return data
